#ifndef __DISARM_H__
#define __DISARM_H__

extern "C" {
typedef unsigned long word;

struct DisOptions {
  word flags;
  char **regnames;    /* pointer to 16 |char *|s: register names */
};

typedef unsigned long address;
typedef struct DisOptions sDisOptions, *pDisOptions;

typedef enum {
  target_None,		/* instruction doesn't refer to an address */
  target_Data,		/* instruction refers to address of data */
  target_FloatS,	/* instruction refers to address of single-float */
  target_FloatD,	/* instruction refers to address of double-float */
  target_FloatE,	/* blah blah extended-float */
  target_FloatP,	/* blah blah packed decimal float */
  target_Code,		/* instruction refers to address of code */
  target_Unknown	/* instruction refers to address of *something* */
} eTargetType;

struct Instruction {
  char text[128];	/* the disassembled instruction */
  int undefined;	/* non-0 if it's an undefined instr */
  int badbits;		/* non-0 if something reserved has the wrong value */
  int oddbits;		/* non-0 if something unspecified isn't 0 */
  int is_SWI;		/* non-0 if it's a SWI */
  word swinum;		/* only set for SWIs */
  address target;	/* address instr refers to */
  eTargetType target_type;	/* and what we expect to be there */
  long offset;		/* offset from register in LDR or STR or similar */
  char * addrstart;	/* start of address part of instruction, or 0 */
};

typedef Instruction *pInstruction;

extern sDisOptions arm_options;
extern pInstruction arm_instr_disassemble( word, address, pDisOptions );
}

#endif // __DISARM_H__
